import java.util.*;

public class client {
	public static void main(String [] args) {
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
		if (orb == null) System.exit(-1);
		try {
			// obtain service from naming server
			org.omg.CORBA.Object ns_obj = orb.resolve_initial_references("NameService");
			org.omg.CosNaming.NamingContext nc
				= org.omg.CosNaming.NamingContextHelper.narrow(ns_obj);
			org.omg.CosNaming.NameComponent [] path
				= { new org.omg.CosNaming.NameComponent("TestServer", "") };
			org.omg.CORBA.Object obj = nc.resolve(path);
			Hello hello = HelloHelper.narrow(obj);

			// use service
			String server = hello.say_hello("Java client");
			System.out.println("answer from: " + server);

			// destroy
			orb.destroy();
		} catch (org.omg.CORBA.ORBPackage.InvalidName exception) {
			exception.printStackTrace(System.out);
		} catch (org.omg.CosNaming.NamingContextPackage.NotFound exception) {
			exception.printStackTrace(System.out);
		} catch (org.omg.CosNaming.NamingContextPackage.CannotProceed exception) {
			exception.printStackTrace(System.out);
		} catch (org.omg.CosNaming.NamingContextPackage.InvalidName exception) {
			exception.printStackTrace(System.out);
		} catch (org.omg.CORBA.COMM_FAILURE exception) {
			exception.printStackTrace(System.out);
		} catch (Exception exception) {
			exception.printStackTrace(System.out);
		}
	}
}
