import java.util.*;

public class server {
	public static void main(String [] args) {
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
		if (orb == null) System.exit(-1);
		try {
			// init POA
			org.omg.CORBA.Object poa_obj = orb.resolve_initial_references("RootPOA");
			org.omg.PortableServer.POA poa
				= org.omg.PortableServer.POAHelper.narrow(poa_obj);
			org.omg.PortableServer.POAManager manager = poa.the_POAManager();

			// create service
			org.omg.CORBA.Object service = poa.servant_to_reference(new Hello_impl());

			// register within naming service
			try {
				org.omg.CORBA.Object ns_obj = orb.resolve_initial_references("NameService");
				if (ns_obj != null) {
					org.omg.CosNaming.NamingContext nc
						= org.omg.CosNaming.NamingContextHelper.narrow(ns_obj);
					org.omg.CosNaming.NameComponent [] name
						= new org.omg.CosNaming.NameComponent[1];
					name[0] = new org.omg.CosNaming.NameComponent("TestServer", "");
					nc.rebind(name, service);
					System.out.println("Server 'TestServer' bound");
				}
			} catch (Exception exception) {
				exception.printStackTrace(System.out);
			}

			// run
			manager.activate();
			orb.run();

			// destroy
			orb.destroy();
		} catch (org.omg.CORBA.UNKNOWN exception) {
			exception.printStackTrace(System.out);
		} catch (org.omg.CORBA.SystemException exception) {
			exception.printStackTrace(System.out);
		} catch (Exception exception) {
			exception.printStackTrace(System.out);
		}
	}
}
